#include "header.h"
#include <sys/stat.h>
#include <array>
#include <algorithm>
#include <iostream>

int main() {
    sem_unlink(SEM_NAME);
    unlink(FIFO_NAME);
    sem_t *sem = sem_open(SEM_NAME, O_CREAT, 0600, 1);
    if (sem == SEM_FAILED) {
        perror("sem_open failed");
        return 1;
    }
    if (mkfifo(FIFO_NAME, 0600) == -1) {
        std::cerr << "Помилка створення іменованого пайпа! Мабуть, проблеми з правами." << std::endl;
        return 1;
    }
#ifdef AUTOTEST
    int numProcesses = 0;
    std::cout << "Введіть кількість дочірніх процесів: ";
    std::cin >> numProcesses;
    
    for (int i = 0; i < numProcesses; ++i) {
        pid_t pid = fork();
        if (pid < 0) {
            std::cerr << "Помилка при створенні процесу!" << std::endl;
            return 1;
        } else if (pid == 0) execl("./worker", "worker", "auto");
    }
#endif
    std::fstream board(BOARDFILE, std::ios::out); // Відкриваємо в режимі запису для очищення
    if (!board.is_open()) {
        std::cerr << "Помилка відкриття файлу " << BOARDFILE << " для очищення!" << std::endl;
        return 1;
    }
    board.close();
    board.open(BOARDFILE, std::ios::in);
#ifdef VERBOSE
    std::cout << "Починаємо! "<< BRAINSTORM_TIME << " секунд на ідеї." << std::endl;
#endif
    int fd = open(FIFO_NAME, O_RDONLY);
    if (fd == -1) {
        std::cerr << "Помилка відкриття іменованого пайпа... У несподіваному місці. Чи його хтось не видалив?" << std::endl;
        return 1;
    }
    char buffer[2];
    std::array<int, TOP_SIZE> maxes;
    maxes.fill(-1);
    
    for (char i=0;i<TOP_SIZE;++i)maxes[i] = -1;
    std::vector<unsigned short> votes;
     while (read(fd, buffer, sizeof(buffer)) > 0) {
        read(fd, buffer, 2);
        char i=atoi(buffer)-1;
        if(i>=votes.size()) votes.resize(i+1);
        votes[i]++;
        sem_post(sem);
    }
    for (size_t i = 0; i < TOP_SIZE; ++i) {
            int maxIndex = -1;
            unsigned short maxValue = 0;
    
            // Знаходимо індекс найбільшого елемента, який ще не обраний
            for (size_t j = 0; j < votes.size(); ++j) {
                if (votes[j] > maxValue && std::find(maxes.begin(), maxes.end(), j) == maxes.end()) {
                    maxValue = votes[j];
                    maxIndex = j;
                }
            }
    
            if (maxIndex != -1) {
                maxes[i] = maxIndex;
            }
        }
    close(fd);
    unlink(FIFO_NAME);
    std::string lines[TOP_SIZE];
    std::string line;
    char lineNumber = 0;
    for (char lineNumber = 0; lineNumber < votes.size(); ++lineNumber){
        std::getline(board, line);
        for (char b = 0; b < TOP_SIZE; ++b)
            if (lineNumber == maxes[b]) {
                lines[b] = line;
                break;
            }
      }
    for (char a=0;a<TOP_SIZE;a++){
        if(maxes[a]==-1){if(!a) std::cout<<"Немає ідей!";break;}
        std::cout<<a+1<<". "<<lines[a]<<std::endl;
    }
    sem_close(sem);
    sem_unlink(SEM_NAME);
    return 0;
}
